import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class R77 extends PApplet {

PGraphics Main, Camxy, Joy, Status;
PImage barra, rotacao, mouse, seta, mouseL, lupa, arrows;
PFont verd, verdS, verdSS;

Button credits, teoria, next, prev, controls, controlst, maisinfo;

float ro, fi, th, ancX, ancY, focX, focY;
int roamW, roamH;                          // cam roam window
int joyRad, joyX, joyY;
float jX, jY, joyMod;
int lightsmode;

int statW, statH, gradH;
int teo;
int dd;  // redraw int
PVector vC;

float mx, my;
float tx, ty;
boolean locked1, locked2, locked3, locked4, mpress, mdrag;    // 1=main 2=roam 3=joystick

int Npil = 1300;
P[] p = new P[Npil];

public void setup ()
{
  smooth();

  frameRate (30);
  size (720,600);
  roamW=140;
  roamH=120;

  statW=width;
  statH=20;
  gradH=20;

  joyRad=60;
  joyX=width-joyRad;
  joyY=height-statH-joyRad-40;
  locked1=locked2=locked3=locked4=mpress=false;

  // mouse wheel trickery
  addMouseWheelListener(new java.awt.event.MouseWheelListener() { 
    public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) { 
      mouseWheel(evt.getWheelRotation());
    }
  }
  ); 

  lid=1;

  //FONTES
  verd = loadFont ("Verdana-20.vlw");
  verdS = loadFont ("Verdana-15.vlw");
  verdSS = loadFont ("Verdana-8.vlw");

  //PGRAPHICS
  Camxy = createGraphics (roamW, roamH, P2D);
  Status = createGraphics (statW, statH, P2D);
  Joy = createGraphics (2*joyRad, 2*joyRad, P3D);
  Main = createGraphics (width, height, P3D);

  //CAMERA VARS
  ro=3500;
  th=PI;
  fi=0.7f;
  focX=1200;//width/2;
  focY=1200;//height/2;

  mx=roamW/2;
  my=roamH/2;

  vC= new PVector (0,0,0);      // camera pointing vector

  // INICIALIZACAO PILINDROS
  iniPilindros();      // inicializa polindros mapeados


    // INICIALIZACAO BARRA STATUS

  barra = createImage (720, 50, ARGB);
  barra.loadPixels();
  for (int y = 0; y < barra.height; y++) {
    for (int x = 0; x < barra.width; x++) {
      int loc = x + y*width;
      barra.pixels[loc] = color(200,240,255,PApplet.parseFloat(y)/barra.height*300);
    }
  }
  barra.updatePixels();
  teo=1;

  metalog=loadImage("metalog1.jpg");
  plogo = loadImage ("plogo.png");
  rotacao = loadImage ("rotation.png");
  seta = loadImage ("arrow.png");
  mouse = loadImage ("mouses.png");
  mouseL = loadImage ("mouse.png");
  lupa = loadImage ("lupa.png");
  arrows = loadImage ("arrows.png");

  //BOTOES
  teoria  = new Button (g, 0, 0, 90, height-20, 140, 30, "Teoria", "Voltar", color (80,150,230,100));
  credits = new Button (g, 0, 0, width-90, height-20, 140, 30, "Cr\u00e9ditos", "Voltar", color (80,150,230,100));
  controls= new Button (g, 0, 0, width/2, height-20, 140, 30, "Controles", "Voltar", color (80,150,230,100));
  next  = new Button (g, 0.1f*width, 0.1f*height-15, 500, 455, 40, 30, ">>", ">>", color (100,100));
  prev  = new Button (g, 0.1f*width, 0.1f*height-15, 80, 455, 40, 30, "<<", "<<", color (100,100));
  controlst = new Button (g, 0.1f*width, 0.1f*height-15,w/4-10,450, 120, 25, "Controles", "Fechar", color (50,255,10,100));
  maisinfo = new Button (g, 0.2f*width, 0.2f*height-15,w/2-115,475, 140, 30, "+ info", "- info", color (50,255,10,100));

  // LIGHTS MODE
  lightsmode=0;
}









public void draw()
{ 

  //!!! println(frameCount +"//"+ fi);
  //println (ancX+" "+ancY+" // "+focX+" "+focY);
  //println (th+" "+fi);

  Main.beginDraw();
  Main.background (0);

  // CAMERA CONTROLS

  //camera(mouseX,  mouseY,10, width/2, height/2, 0, 0, 0, -1); //eyeX, eyeY, eyeZ, centerX, centerY, centerZ, upX, upY, upZ
  Main.camera(focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi), focX, focY, 0, 0, 0, -sin(fi)); 
  vC.set(ro*cos(th)*sin(fi), ro*sin(th)*sin(fi), ro*cos(fi));    // vetor visao da camera

  // LIGHTS CONTROLS
  if (lightsmode==0)
  {
    Main.lights();
    Main.pointLight (80,80,80,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi));
  }
  if (lightsmode==1) 
    Main.spotLight(250,250,250,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi), -cos(th)*sin(fi), -sin(th)*sin(fi), -ro*cos(fi), PI/2, 1);
  if (lightsmode==2) 
    Main.pointLight (255,255,255,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi));



  // PILINDROS CONTROLS
  for (int i=0; i<1300; i++)
    p[i].draw();

  //println ((ancX+ro*cos(th)*sin(fi)) +","+ (ancY+ro*sin(th)*sin(fi)));

  /*triad
   Main.translate(0,0,20);
   Main.stroke(0,0,255);
   Main.line (0,0,0,0,0,20);
   Main.stroke(0,255,0);
   Main.line (0,0,0,0,20,0);
   Main.stroke(255,0,0);
   Main.line (0,0,0,20,0,0);
   Main.stroke(50);
   
   */

  Main.endDraw();
  image (Main,0,0);

  // CAM TRANSLATION WINDOW CONTROLS

  Camxy.beginDraw();
  Camxy.background(0,70,200,180);
  north(th);
  mx = constrain(mx, 1, roamW-1);
  my = constrain(my, 1, roamH-1);
  Camxy.stroke(255);
  Camxy.strokeWeight(2);
  Camxy.translate (mx, roamH-my);
  Camxy.line (-5, 0, 5, 0);
  Camxy.line (0,-5, 0, 5);
  Camxy.endDraw();
  image (Camxy, width-roamW, 0);  


  // JOYSTICK CONTROLS

  if (mpress && mdrag && locked3 && mousePressed && mouseButton==LEFT)
  {
    println ((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY));

    joyMod=(mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY);

    if (joyMod<(joyRad-10)*(joyRad-10))
    {
      jX=(mouseX-joyX+joyRad);
      jY=(mouseY-joyY+joyRad);
    }
    else
    {

      jX=(mouseX-joyX)/sqrt(joyMod)*(joyRad-10)+joyRad;
      jY=(mouseY-joyY)/sqrt(joyMod)*(joyRad-10)+joyRad;
    }

    tx=(mouseX-joyX)*50/joyRad;
    ty=-(mouseY-joyY)*50/joyRad;
    incCam(tx, ty);
  }
  else
  { 
    jX=(joyRad);
    jY=(joyRad);
  }


  Joy.beginDraw();
  Joy.noStroke();
  Joy.background(255,1);
  Joy.fill(50,160,255); // joy color
  Joy.ellipse(joyRad, joyRad, 2*joyRad, 2*joyRad);
  Joy.fill(110,200,255);
  Joy.stroke(110,200,255,180);
  Joy.strokeWeight(10);
  Joy.line (joyRad, joyRad, jX, jY);
  Joy.noStroke();
  Joy.ellipse(jX,jY,20,20);
  Joy.ellipse(joyRad, joyRad,10,10);
  Joy.endDraw();

  tint (255,150); // trickery
  image (Joy, joyX-joyRad, joyY-joyRad);  
  noTint();



  // STATUS BAR MANAGEMENT
  image (barra, 0, height-barra.height);
  if (!credits.isSelected() && !controls.isSelected()) teoria.display();
  if (!teoria.isSelected() && !controls.isSelected())  credits.display();
  if (!credits.isSelected() && !teoria.isSelected())   controls.display();


  if (credits.isSelected())
  {
    showCredits();
  }

  //TEORIA MANAGEMENT
  if (teoria.isSelected())
  {
    showTeoria();
  }
  else if (!maisinfo.isSelected()) teo=1;

  // CONTROLS MANAGEMENT
  if (controls.isSelected())
  {
    showControls();
  }
  else maisinfo.unSelect();
  if (controlst.isSelected())
  {
    showControls();
  }
  if (maisinfo.isSelected())
  {
    teo=4;
    showTeoria();
  }

  if (dd<1 && !mpress)
    noLoop();
  else
    dd--;
}


//CAMERA CONTROLS 

public void incCam (float dx, float dy)
{
  mx += (-sin(th)*dy-cos(th)*dx)/17.2f;
  my += (-cos(th)*dy+sin(th)*dx)/20;

  focY += -sin(th)*dy-cos(th)*dx;
  focX += -cos(th)*dy+sin(th)*dx;

  if (focX<=0) focX=0;
  if (focX>=2400) focX=2400;
  if (focY<=0) focY=0;
  if (focY>=2400) focY=2400;
}

public void translateCam(float mmx, float mmy)
{
  //println (mmx/roamW+" "+mmy/roamH);

  mmx = constrain(mmx, 1, roamW-1);
  mmy = constrain(mmy, 1, roamH-1);

  focX = map (mmy, 1, roamH-1, 0,2400);
  focY = map (mmx, 1, roamW-1, 0,2400);

  //println (focX+" "+focY);
}

public void north (float z)
{
  int p=5;
  Camxy.pushMatrix();
  Camxy.pushStyle();
  Camxy.fill(0,150);
  Camxy.noStroke();
  Camxy.translate(roamW/2, roamH/2);
  Camxy.rotate(z);
  Camxy.beginShape();
  Camxy.vertex (0,4*p);
  Camxy.vertex (3*p,0);
  Camxy.vertex (1.5f*p,0);
  Camxy.vertex (1.5f*p,-4*p);
  Camxy.vertex (-1.5f*p,-4*p);
  Camxy.vertex (-1.5f*p,0);
  Camxy.vertex (-3*p,0);
  Camxy.endShape(CLOSE);
  Camxy.popMatrix();
}


// THREADS
public void mouseDragged ()
{ 

  mdrag=true;
  //println(sqrt((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY)));

  // se estiver no quadradinho, e nao estiver locked nos outros
  if ((mouseX>width-roamW && mouseY<roamH || locked2) && !locked1 && !locked3)                                             // camera translation window
  {
    if (mousePressed && mouseButton == LEFT)
    {
      locked2=true;
      mx=mouseX-(width-roamW);
      my=roamH-mouseY;
      translateCam(mx, my);
    }
  }
  else if (sqrt((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY))<joyRad && !locked1 && !locked2)
  {
    locked3=true;
  }
  else if (!locked1 && !locked2 && !locked3 && mouseY>height-barra.height)
  {
    locked4=true;
  }
  // (se n\u00e3o estiver no quadradinho ou estiver locked1) E se nao estiver locked nos outros

  else if (!locked2 && !locked3 && !locked4 && (!teoria.isSelected() || !(mouseX>0.1f*width && mouseX<0.9f*width && mouseY>0.1f*height-15 && mouseY<0.9f*height-15) || (mousePressed && mouseButton==RIGHT)  ))      // normal camera rotation
  {
    float ratio;
    locked1=true;
    if (ro>300) ratio=ro;
    else ratio=300;
    th+=TWO_PI*(mouseX-pmouseX)/PApplet.parseFloat(width)*ratio/1800;
    fi+=-TWO_PI*(mouseY-pmouseY)/PApplet.parseFloat(height)*ratio/1800;
  }
  //else 

  dd=2;
  loop();
}

public void mousePressed()
{
  mouseDragged();
  // if (credits.isSelected() ) credits.unSelect(); ta dando problema na volt
  mpress=true;

  // RESETS DE RIGHT CLICK
  loop();
  if ((mouseX>width-roamW && mouseY<roamH) && mousePressed && mouseButton==RIGHT) { 
    th=PI; 
    fi = 0.7f;
  }
  if (((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY)<joyRad*joyRad) && mousePressed && mouseButton==RIGHT) { 
    focX=focY=1200; 
    mx=roamW/2; 
    my=roamH/2;
  }

  // buttons mousepressed method

  if (!credits.isSelected() && !controls.isSelected()) teoria.mousePressed(mouseX,mouseY);
  if (!teoria.isSelected() && !controls.isSelected())  credits.mousePressed(mouseX,mouseY);
  if (!credits.isSelected() && !teoria.isSelected())   controls.mousePressed(mouseX,mouseY);
  if ((teoria.isSelected() && teo==4))   controlst.mousePressed(mouseX,mouseY);
  if (controls.isSelected())   maisinfo.mousePressed(mouseX,mouseY);
  next.mousePressed(mouseX,mouseY);
  prev.mousePressed(mouseX,mouseY);

  //if (teoria.isSelected() && mousePressed && (mouseButton == LEFT))
  //teo++;
  //if (!teoria.isSelected()) teo=1;
}

public void mouseReleased ()
{
  locked1=false;
  locked2=false;
  locked3=false;
  locked4=false;
  mpress=false;
  mdrag=false;


  // buttons mousereleased method
  teoria.mouseReleased();
  credits.mouseReleased();
  controls.mouseReleased();
  controlst.mouseReleased();
  next.mouseReleased();
  prev.mouseReleased();
  maisinfo.mouseReleased();

  dd=2;
  loop();
}


public void keyPressed ()
{ 
  if (key==CODED)
  {
    println("))))"+keyCode);
    
    if (keyCode==UP) { 
      incCam(0,20);
    }
    if (keyCode==DOWN) { 
      incCam(0,-20);
    }
    if (keyCode==LEFT) { 
      incCam(-20,0);
    }
    if (keyCode==RIGHT) { 
      incCam(20,0);
    }
    if (keyCode==CONTROL) {
      setAngle(true);
    }
    if (keyCode==33) {
      ro-=50;
      if (ro<50) ro=50;
    }
    if (keyCode==34) {
      ro+=50;
      if (ro>15000) ro=15000;
    }
  }
  else
  {
    //if (key=='s') 
    //  for (int i=0; i<Npil; i++) p[i].incS(-0.1);      // inclinacao da tampa
    //if (key=='w') 
    //  for (int i=0; i<Npil; i++) p[i].incS(0.1);
    //if (key==' ') 
    //  for (int i=0; i<Npil; i++) p[i].setS(0,0);         
    //if (key=='a') 
    //  for (int i=0; i<Npil; i++) p[i].incR(-0.1);        // angulo de rotacao
    //if (key=='d') 
    //  for (int i=0; i<Npil; i++) p[i].incR(0.1);    
    //if (key=='q') 
    //  for (int i=0; i<Npil; i++) p[i].incL(-5);          // largura do pilindro
    //if (key=='e') 
    //  for (int i=0; i<Npil; i++) p[i].incL(5);
    if (key=='/')
      setAngle(true);

    if (key=='1')
      lid=1;
    if (key=='2')
      lid=2;

    if (key==' ') {
      credits.unSelect();
      teoria.unSelect();
      controls.unSelect();
      controlst.unSelect();
    }
  }

  dd=2;
  loop();
}

public void mouseWheel(int delta) 
{
  ro+=50*delta;
  if (ro<50) ro=50;
  dd=2;
  loop();
}

class Button 
{
  PGraphics layer;
  float x, y; // button-centre coords
  String BText1, BText2;       // button text
  int BStateFlag;       // button state: 0 = free / 1 = selected / 2 = pressed (selected instantly)
  boolean WasBSelected;  // previous button state: false = free // true = selected
  
  float BWidth, BHeight; // button dimensions
  
  int fontsize; // calculate fontsize based on text string and internal button size
  
  float c = 2, b = 4; // arbitrary constants (b used to be 4)
  float SAlpha;

  int ContentColour, BColour;
  int shade, light, plateau, selected;
  
  float dxoffset, dyoffset; // offsets of window (layer) where button is being placed at relative to global (0,0) (TOP LEFT CORNER)
  
  Button(PGraphics _layer, float _dxoffset, float _dyoffset, float _x, float _y, 
         float _BWidth, float _BHeight, String _BText1, String _BText2, int _BColour) {
    x = _x;
    y = _y;
    BWidth = _BWidth;
    BHeight = _BHeight;
    BStateFlag = 0;      // Button is initialised as free, default behaviour.
    WasBSelected = false;  // If needed, change var after constructor function call
    BText1 = _BText1;
    BText2 = _BText2;
    layer = _layer;
    dxoffset = _dxoffset;
    dyoffset = _dyoffset;
    BColour = _BColour;
    
    SAlpha = 255;
    SetColours();
  }
  
  
  public void SetColours() {
    plateau = BColour;
    shade = lerpColor(0xff000000, BColour, 0.8f); shade = color(red(shade), green(shade), blue(shade), alpha(BColour));
    light = lerpColor(0xffFFFFFF, BColour, 0.8f); light = color(red(light), green(light), blue(light), alpha(BColour));
    selected = color(255-red(BColour), 255-green(BColour), 255-blue(BColour));
  }
  
public void DisplayColours() {
    int TMPcolour;
    
    TMPcolour = plateau;
    
    layer.fill(TMPcolour);
    layer.noStroke();
    layer.rectMode(CENTER);
    layer.rect(x, y, BWidth, BHeight);
    
    switch(BStateFlag) {
      case 0: // free
        layer.fill(light);
        break;
      case 1: // selected
        layer.fill(shade);
        break;
      case 2: // pressed
        layer.fill(lerpColor(selected, shade, 0.9f));
        break;
    }
    layer.beginShape(TRIANGLE_STRIP); // split in 2 shapes to avoid WEIRD blending effect after color change
    layer.vertex(x + BWidth/2 - b, y - BHeight/2 + b);
    layer.vertex(x + BWidth/2, y - BHeight/2);
    layer.vertex(x - BWidth/2 + b, y - BHeight/2 + b);
    layer.vertex(x - BWidth/2, y - BHeight/2);
    layer.vertex(x - BWidth/2 + b, y + BHeight/2 - b);
    layer.vertex(x - BWidth/2, y + BHeight/2);
    layer.endShape();
    
    switch(BStateFlag) {
      case 0: // free
        layer.fill(shade);
        break;
      case 1: // selected
        layer.fill(light);
        break;
      case 2: // pressed
        layer.fill(lerpColor(selected, light, 0.9f));
        break;
    }
    layer.beginShape(TRIANGLE_STRIP);
    layer.vertex(x - BWidth/2 + b, y + BHeight/2 - b);
    layer.vertex(x - BWidth/2, y + BHeight/2);
    layer.vertex(x + BWidth/2 - b, y + BHeight/2 - b);
    layer.vertex(x + BWidth/2, y + BHeight/2);
    layer.vertex(x + BWidth/2 - b, y - BHeight/2 + b);
    layer.vertex(x + BWidth/2, y - BHeight/2);
    layer.endShape();
    
    
    switch(BStateFlag) { // this is the colour of the text, left ready to be applied in text created in display, after this funciton call
      case 0: // free
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , shade, 0.2f);
        break;
      case 1: // selected
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , light, 0.2f);
        break;
      case 2: // pressed
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , TMPcolour, 0.7f);
        break;
    }
  }
  
  public void display() {
    layer.pushStyle();
    DisplayColours();
    layer.fill(ContentColour);
    layer.textAlign(CENTER, CENTER);
    layer.textFont (verd, 16);
    if (isSelected())
    {
      layer.fill (255);
      layer.text(BText2, x, y);
    }
    else
      layer.text(BText1, x, y);
    layer.popStyle();
  }
  
  public void mousePressed(float mX, float mY) {
    float dx = abs(mX - (x + dxoffset));
    float dy = abs(mY - (y + dyoffset));
    //dx e dy: testar posicao do mouse pra ver se quando eh clicado estah sobre o botao
    //mouseButton: testar pra soh considerar clique com botao esquerdo (botao direito eh inocuo)
    //se clicou com o esquerdo E estah dentro da area do botao
    if (mouseButton == LEFT && dx <= BWidth/2 && dy <= BHeight/2) {
      switch(BStateFlag) {
        case 0: // se estah FREE
          BStateFlag = 2; // vai pra PRESSED
          WasBSelected = false; // e antes estava FREE
          break;
        case 1: // se estah SELECTED
          BStateFlag = 2; // vai pra PRESSED
          WasBSelected = true; // e antes estava SELECTED
          break;
      }
    }
  }
  
  public void mouseReleased() {
    //se estah PRESSED e estava FREE -> SELECTED
    //se estah PRESSED e estava SELECTED -> FREE
    if(BStateFlag == 2) {
      BStateFlag = (WasBSelected) ? (0) : (1);
    }
  }
  
  public void free() {
    WasBSelected = true;
    BStateFlag = 0;
  }
  
  public boolean isSelected() {
    if (BStateFlag == 1) return true;
    else return false;
  }
  
  public boolean wasSelected() {
    return WasBSelected;
  }
  
  public boolean isPressed() {
    if (BStateFlag == 2) return true;
    else return false;
  }
  
  public void Select() {
    BStateFlag = 1;
    WasBSelected = false;
  }
  
  public void unSelect () {
    BStateFlag = 0;
    WasBSelected = true;
  }
    
  
  public void Press() {
    BStateFlag = 2;
  }
  
  public float GetParameters(char p) {
    float TMP = 0;
    switch(p) {
      case 'x': TMP = x; break;
      case 'y': TMP = y; break;
      case 'w': TMP = BWidth; break;
      case 'h': TMP = BHeight; break;
    }
    return TMP;
  }
  
  public String GetText() {
    if (isSelected())
    return BText2;
    else
    return BText2;
  }
  
  public int GetBGColour() {
    return BColour;
  }
  
  public void SetPosition(float _x, float _y) {
    x = _x; y = _y;
  }
  
  public void SetSize(float _BWidth, float _BHeight) {
    BWidth = _BWidth; BHeight = _BHeight;
  }
  
  public void SetText(String _BText1, String _BText2) {
    BText1 = _BText1;
    BText2 = _BText2;
  }
  
  public void SetBGColour(int _BColour) {
    BColour = _BColour;
    //Update Stuff
    //SetColours();
  }
  
  public void SetWindow(PGraphics _layer, float _dxoffset, float _dyoffset) {
    dxoffset = _dxoffset; dyoffset = _dyoffset;
    if (_layer != null) layer = _layer; // flag, to only set offsets
  }
}

PImage plogo;

public void showCredits ()
{
  int h, w;
  float l, fontsize;
  h=height-50;
  w=width-10;
  fontsize = 14;
  
  pushMatrix();
  fill (255,120);
  //rect (0,0,width, height);
  
  translate ((width-w)/2, (height-h)/2-15);
  fill (255,220);
  noStroke();
  rect (0,0, w, h);
  
  l=0.08f*h;
  fill(0);
  textAlign(CENTER);
  textFont (verd, 16);
  text ("CR\u00c9DITOS",w/2, 20);
  textAlign(LEFT);
  
  textFont (verd, fontsize);
  text ("Desenvolvimento:",15, l);
  text ("Giovanni Garaldi Biasi (aluno do 3\u00ba ano do Curso de Engenharia Mec\u00e2nica,\nEscola Polit\u00e9cnica da Universidade de S\u00e3o Paulo - SP, Brasil)",145, l);
  l += fontsize*3;
  text ("Orienta\u00e7\u00e3o:",15, l);
  text ("Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metal\u00fargica e\nde Materiais,Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo - SP, Brasil)",145, l);
  l += fontsize*3;
  text ("Texto:",15, l);
  text ("Giovanni Garaldi Biasi",145, l);
  text ("Ultima Modifica\u00e7\u00e3o: 04/04/2012", 420, l);
  
  l += fontsize*3;
  text ("Colabora\u00e7\u00e3o:",15, l);
  text ("Rafael Nahat (UI Objects)",145, l);
  text ("Plataforma:", 420, l);
  text ("Processing v.1.2.1", 510, l);
  image(plogo, 650, l-30);
  
  
  fontsize=15;
  textFont (verd, fontsize);
  l += fontsize*3;
  text ("Sobre a Anima\u00e7\u00e3o:",15, l);
  textFont (verd, fontsize);
  l += fontsize*1.2f;
  text ("A simula\u00e7\u00e3o \"Metalografia\" foi desenvolvida no contexto do projeto 'Anima\u00e7\u00f5es para \n" +
        "Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos Materiais', integrante do 'Programa \n"+
        "Ensinar com Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo, \u00e0 qual \n" +
        "expressamos agradecimento pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica.\n(Projeto 2882 -2011)."
        ,15, l);
  
  l += fontsize*8;
  textFont (verd, fontsize);
  fill(1,43,77);
  text ("Sobre o Processing:",15, l);
  //fill(0);
  textFont (verd, fontsize);
  l += fontsize*1.2f;
  text ("Processing \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desenvolvimento opensource, \n" +
        "multiplataforma, concebido para artes eletr\u00f4nicas e comunidades de desenho visual \n"+
        "baseado em Java, que conta com o compartilhamento de c\u00f3digos e bibliotecas entre\n" +
        "usu\u00e1rios em uma comunidade online. Foi iniciado em 2001 por Casey Reas e Ben Fry,\n" +
        "pesquisadores do MIT (Intituto de Tecnologia de Massachussets, Cambridge-MA, EUA),\n"+
        "e disponibilizado gratuitamente como software livre no site 'processing.org', onde \u00e9\n"+
        "poss\u00edvel fazer download e encontrar diversas refer\u00eancias para seu uso."
        ,15, l);
  
  fontsize=15;
  fill (0);
  textFont (verd, fontsize);      
  l += fontsize*10;
  text ("Refer\u00eancias:",15, l);
  text ("CALLISTER, William D Jr. Ci\u00eancia e Engenharia de Materiais -\nUma Introdu\u00e7\u00e3o. 7\u00aa ed. S\u00e3o Paulo: LTC, 2008", 130, l);
  l += fontsize*2;
        
  popMatrix();
}


//========================================================== CONTROLS =====================================================
// color (155,0,255);

public void showControls ()
{
  int h, w;
  float l, fontsize;
  h=PApplet.parseInt(height*0.6f);
  w=PApplet.parseInt(width*0.6f);
  fontsize = 14;
  
  pushMatrix();
  pushStyle();
  fill (255,120);
  //rect (0,0,width, height);
  
  translate ((width-w)/2, (height-h)/2-15);
  fill (255,180);
  noStroke();
  rect (0,0, w, h);
  
  fill(0);
  textAlign(CENTER);
  textFont(verd,20);
  text ("CONTROLES",w/2, 20);
  
  maisinfo.display();
  
  image (arrows, 10,60);
  textFont (verd, 15);
  text("Transla\u00e7\u00e3o\nda C\u00e2mera", 70,160);
  textAlign(LEFT);
  text ("'/' = Troca inclina\u00e7\u00e3o dos planos\n\n"+
        "'ESPA\u00c7O' = Fecha todas as janelas\n\n"+
        "'PAGE UP' = Zoom IN\n"+
        "'PAGE DOWN' = Zoom OUT"
 
  ,150,70);
  
  
  
  stroke (100,180);
  line (5,190,425,190);
  // ---------------------
    
  fill(0);
  textAlign(LEFT);
  
  textFont (verdS, fontsize);
  
  image (mouseL, 80,200);
  
  tint(155,0,255,180);
  image (lupa, 145,260);
  
  tint (127,200,250);
  image (rotacao, 10,260);
  
  fill(127,250,200,100);
  stroke(127,250,200,180);
  rect(240,250,180,100);
  
  strokeWeight(4);
  noFill();
  beginShape();
  vertex(150,220);
  vertex(280,220);
  vertex(280,250);
  endShape();
  stroke(127,200,250,180);
  beginShape();
  vertex(110,230);
  vertex(57,230);
  vertex(57,260);

  endShape();
  stroke (155,0,255,180);
  beginShape();
  vertex(130,230);
  vertex(130,280);
  vertex(147,280);
  endShape();
  
  noTint();
  image (Camxy, 245,260,40,35);
  tint (255,180);
  image (Joy, 245, 305,40,40);
  
  fill(0);
  text ("Reset Angulo", 310,285);
  text ("Reset Centro", 310,330);
  
  popStyle();
  popMatrix();
}

int w, h;
int[] x, y, z, r;
float[] s;
int n;
int lid;
float maxS = 2;

public void iniPilindros()
{
  w=h=1200;
  x = new int[1000];
  y = new int[1000];
  z = new int[1000];
  r = new int[1000];
  s= new float[2000];
  
  //grain1
  n=0;
       x[2*n]= 150; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]= 192; y[2*n+1]=  25; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 132; y[2*n]=  25; z[2*n]= 0;  x[2*n+1]= 190; y[2*n+1]=  58; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 130; y[2*n]=  60; z[2*n]= 0;  x[2*n+1]= 185; y[2*n+1]=  92; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 130; y[2*n]=  92; z[2*n]= 0;  x[2*n+1]= 182; y[2*n+1]= 122; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 130; y[2*n]= 126; z[2*n]= 0;  x[2*n+1]= 180; y[2*n+1]= 156; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 130; y[2*n]= 162; z[2*n]= 0;  x[2*n+1]= 178; y[2*n+1]= 188; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 128; y[2*n]= 196; z[2*n]= 0;  x[2*n+1]= 172; y[2*n+1]= 222; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 126; y[2*n]= 230; z[2*n]= 0;  x[2*n+1]= 160; y[2*n+1]= 252; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 126; y[2*n]= 260; z[2*n]= 0;  x[2*n+1]= 144; y[2*n+1]= 272; z[2*n+1]=   0; r[n]=15;
  //n=8
  
  //grain2
  n++;
  //n=9
       x[2*n]= 132; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]= 124; y[2*n+1]= 290; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 102; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]=  92; y[2*n+1]= 310; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]=  72; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]=  62; y[2*n+1]= 326; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]=  42; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]=  32; y[2*n+1]= 338; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]=  12; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]=   0; y[2*n+1]= 344; z[2*n+1]= 0; r[n]=15;
  //n=13
  
  //grain3
  n++;
  //n=14
       x[2*n]=   0; y[2*n]= 362; z[2*n]= 0;  x[2*n+1]=  12; y[2*n+1]= 348; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=   0; y[2*n]= 416; z[2*n]= 0;  x[2*n+1]=  54; y[2*n+1]= 328; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=   6; y[2*n]= 464; z[2*n]= 0;  x[2*n+1]= 108; y[2*n+1]= 300; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  42; y[2*n]= 458; z[2*n]= 0;  x[2*n+1]= 174; y[2*n+1]= 254; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  88; y[2*n]= 442; z[2*n]= 0;  x[2*n+1]= 198; y[2*n+1]= 270; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 128; y[2*n]= 434; z[2*n]= 0;  x[2*n+1]= 222; y[2*n+1]= 288; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 166; y[2*n]= 430; z[2*n]= 0;  x[2*n+1]= 248; y[2*n+1]= 302; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 200; y[2*n]= 430; z[2*n]= 0;  x[2*n+1]= 278; y[2*n+1]= 312; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 234; y[2*n]= 432; z[2*n]= 0;  x[2*n+1]= 306; y[2*n+1]= 320; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 268; y[2*n]= 434; z[2*n]= 0;  x[2*n+1]= 338; y[2*n+1]= 324; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 304; y[2*n]= 436; z[2*n]= 0;  x[2*n+1]= 370; y[2*n+1]= 330; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 338; y[2*n]= 438; z[2*n]= 0;  x[2*n+1]= 398; y[2*n+1]= 342; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 372; y[2*n]= 438; z[2*n]= 0;  x[2*n+1]= 420; y[2*n+1]= 360; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 414; y[2*n]= 426; z[2*n]= 0;  x[2*n+1]= 426; y[2*n+1]= 404; z[2*n+1]=   0; r[n]=15;
  //n=27

  //grain4
  n++;
  //n=28
       x[2*n]= 196+10; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]= 472; y[2*n+1]=   0; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 194+10; y[2*n]=  20; z[2*n]= 0;  x[2*n+1]= 504; y[2*n+1]=  20; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 190+10; y[2*n]=  40; z[2*n]= 0;  x[2*n+1]= 468; y[2*n+1]=  40; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 188+10; y[2*n]=  60; z[2*n]= 0;  x[2*n+1]= 436; y[2*n+1]=  60; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 186+10; y[2*n]=  80; z[2*n]= 0;  x[2*n+1]= 398; y[2*n+1]=  80; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 184+10; y[2*n]= 100; z[2*n]= 0;  x[2*n+1]= 366; y[2*n+1]= 100; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 182+10; y[2*n]= 120; z[2*n]= 0;  x[2*n+1]= 332; y[2*n+1]= 120; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 180+10; y[2*n]= 140; z[2*n]= 0;  x[2*n+1]= 300; y[2*n+1]= 140; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 178+10; y[2*n]= 160; z[2*n]= 0;  x[2*n+1]= 262; y[2*n+1]= 160; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 176+10; y[2*n]= 180; z[2*n]= 0;  x[2*n+1]= 226; y[2*n+1]= 180; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 174+10; y[2*n]= 200; z[2*n]= 0;  x[2*n+1]= 198; y[2*n+1]= 200; z[2*n+1]=   0; r[n]=10;
  //n=38
  
  //grain5
  n++;
  //n=39
       x[2*n]= 544; y[2*n]=  40; z[2*n]= 0;  x[2*n+1]= 530; y[2*n+1]=  72; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 528; y[2*n]=  30; z[2*n]= 0;  x[2*n+1]= 500; y[2*n+1]=  90; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 510; y[2*n]=  20; z[2*n]= 0;  x[2*n+1]= 472; y[2*n+1]= 110; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 482; y[2*n]=  30; z[2*n]= 0;  x[2*n+1]= 440; y[2*n+1]= 128; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 454; y[2*n]=  48; z[2*n]= 0;  x[2*n+1]= 412; y[2*n+1]= 144; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 426; y[2*n]=  64; z[2*n]= 0;  x[2*n+1]= 382; y[2*n+1]= 162; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 398; y[2*n]=  80; z[2*n]= 0;  x[2*n+1]= 352; y[2*n+1]= 180; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 362; y[2*n]= 100; z[2*n]= 0;  x[2*n+1]= 320; y[2*n+1]= 198; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 332; y[2*n]= 120; z[2*n]= 0;  x[2*n+1]= 296; y[2*n+1]= 218; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 304; y[2*n]= 138; z[2*n]= 0;  x[2*n+1]= 262; y[2*n+1]= 234; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 276; y[2*n]= 152; z[2*n]= 0;  x[2*n+1]= 232; y[2*n+1]= 254; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 244; y[2*n]= 168; z[2*n]= 0;  x[2*n+1]= 200; y[2*n+1]= 270; z[2*n+1]=   0; r[n]=11;
  n++; x[2*n]= 214; y[2*n]= 188; z[2*n]= 0;  x[2*n+1]= 182; y[2*n+1]= 260; z[2*n+1]=   0; r[n]=11;
  //n=52
  
  //grain6
  n++;
  //n=53
       x[2*n]= 560; y[2*n]=  60; z[2*n]= 0;  x[2*n+1]= 610; y[2*n+1]= 120; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 534; y[2*n]=  70; z[2*n]= 0;  x[2*n+1]= 636; y[2*n+1]= 192; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 510; y[2*n]=  86; z[2*n]= 0;  x[2*n+1]= 618; y[2*n+1]= 218; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 488; y[2*n]= 100; z[2*n]= 0;  x[2*n+1]= 598; y[2*n+1]= 236; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 462; y[2*n]= 114; z[2*n]= 0;  x[2*n+1]= 576; y[2*n+1]= 254; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 436; y[2*n]= 130; z[2*n]= 0;  x[2*n+1]= 550; y[2*n+1]= 274; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 406; y[2*n]= 148; z[2*n]= 0;  x[2*n+1]= 528; y[2*n+1]= 292; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 380; y[2*n]= 162; z[2*n]= 0;  x[2*n+1]= 504; y[2*n+1]= 310; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 356; y[2*n]= 178; z[2*n]= 0;  x[2*n+1]= 480; y[2*n+1]= 328; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 330; y[2*n]= 194; z[2*n]= 0;  x[2*n+1]= 454; y[2*n+1]= 346; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 300; y[2*n]= 210; z[2*n]= 0;  x[2*n+1]= 430; y[2*n+1]= 364; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 274; y[2*n]= 224; z[2*n]= 0;  x[2*n+1]= 364; y[2*n+1]= 330; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 250; y[2*n]= 240; z[2*n]= 0;  x[2*n+1]= 316; y[2*n+1]= 320; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 226; y[2*n]= 256; z[2*n]= 0;  x[2*n+1]= 274; y[2*n+1]= 310; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 206; y[2*n]= 268; z[2*n]= 0;  x[2*n+1]= 220; y[2*n+1]= 290; z[2*n+1]=   0; r[n]=15;
  //n=67
  
  
  //grain7
  n++;
  //n=68
       x[2*n]= 648; y[2*n]= 170; z[2*n]= 0;  x[2*n+1]= 634; y[2*n+1]= 170; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 662; y[2*n]= 160; z[2*n]= 0;  x[2*n+1]= 630; y[2*n+1]= 160; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 680; y[2*n]= 150; z[2*n]= 0;  x[2*n+1]= 626; y[2*n+1]= 150; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 694; y[2*n]= 140; z[2*n]= 0;  x[2*n+1]= 620; y[2*n+1]= 140; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 708; y[2*n]= 130; z[2*n]= 0;  x[2*n+1]= 616; y[2*n+1]= 130; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 724; y[2*n]= 120; z[2*n]= 0;  x[2*n+1]= 610; y[2*n+1]= 120; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 740; y[2*n]= 110; z[2*n]= 0;  x[2*n+1]= 602; y[2*n+1]= 110; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 754; y[2*n]= 100; z[2*n]= 0;  x[2*n+1]= 598; y[2*n+1]= 100; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 764; y[2*n]=  90; z[2*n]= 0;  x[2*n+1]= 592; y[2*n+1]=  90; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 780; y[2*n]=  80; z[2*n]= 0;  x[2*n+1]= 584; y[2*n+1]=  80; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 794; y[2*n]=  70; z[2*n]= 0;  x[2*n+1]= 576; y[2*n+1]=  70; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 808; y[2*n]=  60; z[2*n]= 0;  x[2*n+1]= 568; y[2*n+1]=  60; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 820; y[2*n]=  50; z[2*n]= 0;  x[2*n+1]= 558; y[2*n+1]=  50; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 840; y[2*n]=  40; z[2*n]= 0;  x[2*n+1]= 546; y[2*n+1]=  40; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 860; y[2*n]=  30; z[2*n]= 0;  x[2*n+1]= 530; y[2*n+1]=  30; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 884; y[2*n]=  20; z[2*n]= 0;  x[2*n+1]= 514; y[2*n+1]=  20; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 910; y[2*n]=  10; z[2*n]= 0;  x[2*n+1]= 498; y[2*n+1]=  10; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 950; y[2*n]=   0; z[2*n]= 0;  x[2*n+1]= 470; y[2*n+1]=   0; z[2*n+1]=   0; r[n]=5;
  //n=85
  
  
  //grain8
  n++;
  //n=86
       x[2*n]= 924; y[2*n]= 274; z[2*n]= 0;  x[2*n+1]=  990; y[2*n+1]= 370; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 874; y[2*n]= 252; z[2*n]= 0;  x[2*n+1]= 1016; y[2*n+1]= 458; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 738; y[2*n]= 110; z[2*n]= 0;  x[2*n+1]=  750; y[2*n+1]= 126; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 818; y[2*n]= 226; z[2*n]= 0;  x[2*n+1]= 1044; y[2*n+1]= 556; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 716; y[2*n]= 126; z[2*n]= 0;  x[2*n+1]=  750; y[2*n+1]= 174; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 770; y[2*n]= 202; z[2*n]= 0;  x[2*n+1]= 1056; y[2*n+1]= 626; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 688; y[2*n]= 144; z[2*n]= 0;  x[2*n+1]= 1018; y[2*n+1]= 624; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 666; y[2*n]= 160; z[2*n]= 0;  x[2*n+1]=  980; y[2*n+1]= 620; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 648; y[2*n]= 176; z[2*n]= 0;  x[2*n+1]=  940; y[2*n+1]= 620; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 660; y[2*n]= 256; z[2*n]= 0;  x[2*n+1]=  902; y[2*n+1]= 616; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 674; y[2*n]= 336; z[2*n]= 0;  x[2*n+1]=  744; y[2*n+1]= 436; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 780; y[2*n]= 488; z[2*n]= 0;  x[2*n+1]=  860; y[2*n+1]= 608; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 680; y[2*n]= 400; z[2*n]= 0;  x[2*n+1]=  710; y[2*n+1]= 438; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 786; y[2*n]= 550; z[2*n]= 0;  x[2*n+1]=  818; y[2*n+1]= 590; z[2*n+1]=   0; r[n]=15+1;
  //n=99
  
  //grain9
  n++;
  //n=100
       x[2*n]= 220; y[2*n]= 430; z[2*n]= 0;  x[2*n+1]= 236; y[2*n+1]= 450; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 182; y[2*n]= 430; z[2*n]= 0;  x[2*n+1]= 216; y[2*n+1]= 472; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 146; y[2*n]= 434; z[2*n]= 0;  x[2*n+1]= 200; y[2*n+1]= 502; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]= 112; y[2*n]= 436; z[2*n]= 0;  x[2*n+1]= 186; y[2*n+1]= 530; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=  78; y[2*n]= 444; z[2*n]= 0;  x[2*n+1]= 170; y[2*n+1]= 558; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=  50; y[2*n]= 458; z[2*n]= 0;  x[2*n+1]= 158; y[2*n+1]= 590; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=  18; y[2*n]= 464; z[2*n]= 0;  x[2*n+1]= 148; y[2*n+1]= 624; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 490; z[2*n]= 0;  x[2*n+1]= 136; y[2*n+1]= 654; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 538; z[2*n]= 0;  x[2*n+1]= 124; y[2*n+1]= 694; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 588; z[2*n]= 0;  x[2*n+1]=  96; y[2*n+1]= 706; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 638; z[2*n]= 0;  x[2*n+1]=  68; y[2*n+1]= 718; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 688; z[2*n]= 0;  x[2*n+1]=  36; y[2*n+1]= 730; z[2*n+1]=   0; r[n]=15+1;
  n++; x[2*n]=   0; y[2*n]= 732; z[2*n]= 0;  x[2*n+1]=   8; y[2*n+1]= 740; z[2*n+1]=   0; r[n]=15+1;
  //n=112
  
 
 //grain10
  n++;
  //n=113
       //x[2*n]= 0; y[2*n]= 742; z[2*n]= 0;  x[2*n+1]= 124; y[2*n+1]= 698; z[2*n+1]=   0; r[n]=15; //excessivo! (mas accounted)
  n++; x[2*n]= 0; y[2*n]= 762; z[2*n]= 0;  x[2*n+1]= 122; y[2*n+1]= 718; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 0; y[2*n]= 784; z[2*n]= 0;  x[2*n+1]= 124; y[2*n+1]= 738; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 0; y[2*n]= 804; z[2*n]= 0;  x[2*n+1]= 128; y[2*n+1]= 758; z[2*n+1]=   0; r[n]=15;
  n++; //x[2*n]= 0; y[2*n]= 826; z[2*n]= 0;  x[2*n+1]= 132; y[2*n+1]= 780; z[2*n+1]=   0; r[n]=15;
  //n=117
  
  //grain11
  n++;
  //n=118
       x[2*n]=  22; y[2*n]= 998; z[2*n]= 0;  x[2*n+1]=   0; y[2*n+1]= 970; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  54; y[2*n]= 992; z[2*n]= 0;  x[2*n+1]=   0; y[2*n+1]= 924; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  90; y[2*n]= 990; z[2*n]= 0;  x[2*n+1]=   0; y[2*n+1]= 878; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 122; y[2*n]= 984; z[2*n]= 0;  x[2*n+1]=   0; y[2*n+1]= 830; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 158; y[2*n]= 980; z[2*n]= 0;  x[2*n+1]=  32; y[2*n+1]= 820; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 194; y[2*n]= 974; z[2*n]= 0;  x[2*n+1]=  60; y[2*n+1]= 808; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 134; y[2*n]= 852; z[2*n]= 0;  x[2*n+1]=  90; y[2*n+1]= 798; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 136; y[2*n]= 810; z[2*n]= 0;  x[2*n+1]= 118; y[2*n+1]= 788; z[2*n+1]=   0; r[n]=15;
  //n=125
  
  //grain12
  n++;
  //n=126
       x[2*n]= 300; y[2*n]= 438; z[2*n]= 0;  x[2*n+1]= 300; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 280; y[2*n]= 434; z[2*n]= 0;  x[2*n+1]= 280; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 260; y[2*n]= 434; z[2*n]= 0;  x[2*n+1]= 260; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 240; y[2*n]= 446; z[2*n]= 0;  x[2*n+1]= 240; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 220; y[2*n]= 470; z[2*n]= 0;  x[2*n+1]= 220; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 200; y[2*n]= 500; z[2*n]= 0;  x[2*n+1]= 200; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 180; y[2*n]= 544; z[2*n]= 0;  x[2*n+1]= 180; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 160; y[2*n]= 586; z[2*n]= 0;  x[2*n+1]= 160; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 140; y[2*n]= 650; z[2*n]= 0;  x[2*n+1]= 140; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; //x[2*n]= 120; y[2*n]= 650; z[2*n]= 0;  x[2*n+1]= 120; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  //n=135
  
  //grain13
  n++;
  //n=136
       x[2*n]= 300; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 440; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 460; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 460; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 480; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 480; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 500; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 520; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 520; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 540; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 540; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 560; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 560; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 580; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 580; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 600; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 600; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 620; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 620; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 640; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 640; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 660; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 660; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 680; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 680; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 700; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 700; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 720; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 720; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 740; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 740; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 760; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 760; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 780; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 780; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 300; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  //n=154
  
  //grain14
  n++;
  //n=155
     //x[2*n]= 350; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 350; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 370; y[2*n]= 438; z[2*n]= 0;  x[2*n+1]= 370; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 390; y[2*n]= 432; z[2*n]= 0;  x[2*n+1]= 390; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 410; y[2*n]= 424; z[2*n]= 0;  x[2*n+1]= 410; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 430; y[2*n]= 416; z[2*n]= 0;  x[2*n+1]= 430; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 450; y[2*n]= 480; z[2*n]= 0;  x[2*n+1]= 450; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 470; y[2*n]= 560; z[2*n]= 0;  x[2*n+1]= 470; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 490; y[2*n]= 636; z[2*n]= 0;  x[2*n+1]= 490; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 510; y[2*n]= 710; z[2*n]= 0;  x[2*n+1]= 510; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 530; y[2*n]= 780; z[2*n]= 0;  x[2*n+1]= 530; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  //n=164
 
 //grain15
  n++;
  //n=165
       x[2*n]= 500; y[2*n]= 950; z[2*n]= 0;  x[2*n+1]= 486; y[2*n+1]= 960; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 500; y[2*n]= 916; z[2*n]= 0;  x[2*n+1]= 452; y[2*n+1]= 958; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 500; y[2*n]= 872; z[2*n]= 0;  x[2*n+1]= 400; y[2*n+1]= 962; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 500; y[2*n]= 832; z[2*n]= 0;  x[2*n+1]= 342; y[2*n+1]= 970; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 488; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 338; y[2*n+1]= 944; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 448; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 316; y[2*n+1]= 920; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 404; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 224; y[2*n+1]= 960; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 356; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 188; y[2*n+1]= 952; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 314; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 166; y[2*n+1]= 934; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 268; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 150; y[2*n+1]= 910; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 222; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 138; y[2*n+1]= 878; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 176; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 138; y[2*n+1]= 840; z[2*n+1]=   0; r[n]=15;
  //n=176

//grain16
  n++;
  //n=177
       x[2*n]= 524; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 560; y[2*n+1]= 1008; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 506; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 538; y[2*n+1]=  986; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 500; y[2*n]= 900; z[2*n]= 0;  x[2*n+1]= 514; y[2*n+1]=  972; z[2*n+1]=   0; r[n]=15;
  //n=179
  
  
  //grain17
  n++;
  //n=180
       x[2*n]= 428; y[2*n]= 394; z[2*n]= 0;  x[2*n+1]= 500; y[2*n+1]= 310; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 436; y[2*n]= 426; z[2*n]= 0;  x[2*n+1]= 642; y[2*n+1]= 204; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 470; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 652; y[2*n+1]= 236; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 508; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 660; y[2*n+1]= 270; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 548; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 668; y[2*n+1]= 308; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 588; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 674; y[2*n+1]= 340; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 630; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 678; y[2*n+1]= 384; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 668; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 684; y[2*n+1]= 420; z[2*n+1]=   0; r[n]=15;
  // 17B
  n++; x[2*n]= 464; y[2*n]= 532; z[2*n]= 0;  x[2*n+1]= 492; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 472; y[2*n]= 564; z[2*n]= 0;  x[2*n+1]= 532; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 482; y[2*n]= 598; z[2*n]= 0;  x[2*n+1]= 572; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 490; y[2*n]= 630; z[2*n]= 0;  x[2*n+1]= 612; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 500; y[2*n]= 668; z[2*n]= 0;  x[2*n+1]= 652; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 510; y[2*n]= 702; z[2*n]= 0;  x[2*n+1]= 692; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 520; y[2*n]= 738; z[2*n]= 0;  x[2*n+1]= 736; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 529; y[2*n]= 772; z[2*n]= 0;  x[2*n+1]= 776; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 550; y[2*n]= 792; z[2*n]= 0;  x[2*n+1]= 784; y[2*n+1]= 536; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 620; y[2*n]= 760; z[2*n]= 0;  x[2*n+1]= 788; y[2*n+1]= 578; z[2*n+1]=   0; r[n]=15;
  //n=197
 
 
 //grain18
  n++;
  //n=198
       x[2*n]= 728; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 774; y[2*n+1]= 452; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 616; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 778; y[2*n+1]= 484; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 514; y[2*n]= 440; z[2*n]= 0;  x[2*n+1]= 724; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 444; y[2*n]= 452; z[2*n]= 0;  x[2*n+1]= 610; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 450; y[2*n]= 482; z[2*n]= 0;  x[2*n+1]= 498; y[2*n+1]= 500; z[2*n+1]=   0; r[n]=15;
  //n=202
  
  //grain19
  n++;
  //n=203
       x[2*n]= 1016; y[2*n]= 1120; z[2*n]= 0;  x[2*n+1]= 1024; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  992; y[2*n]= 1074; z[2*n]= 0;  x[2*n+1]= 1006; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  966; y[2*n]= 1044; z[2*n]= 0;  x[2*n+1]=  986; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  894; y[2*n]=  614; z[2*n]= 0;  x[2*n+1]=  968; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  876; y[2*n]=  610; z[2*n]= 0;  x[2*n+1]=  948; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  854; y[2*n]=  606; z[2*n]= 0;  x[2*n+1]=  928; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  834; y[2*n]=  600; z[2*n]= 0;  x[2*n+1]=  908; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  812; y[2*n]=  590; z[2*n]= 0;  x[2*n+1]=  888; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  789; y[2*n]=  582; z[2*n]= 0;  x[2*n+1]=  862; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  //n=211
 
 //grain20A
  n++;
  //n=212
       x[2*n]= 250; y[2*n]=  960; z[2*n]= 0;  x[2*n+1]= 274; y[2*n+1]=  960; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 160; y[2*n]=  980; z[2*n]= 0;  x[2*n+1]= 250; y[2*n+1]=  980; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1000; z[2*n]= 0;  x[2*n+1]= 230; y[2*n+1]= 1000; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1020; z[2*n]= 0;  x[2*n+1]= 210; y[2*n+1]= 1020; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1040; z[2*n]= 0;  x[2*n+1]= 188; y[2*n+1]= 1040; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1060; z[2*n]= 0;  x[2*n+1]= 168; y[2*n+1]= 1060; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1080; z[2*n]= 0;  x[2*n+1]= 146; y[2*n+1]= 1080; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1100; z[2*n]= 0;  x[2*n+1]= 122; y[2*n+1]= 1100; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1120; z[2*n]= 0;  x[2*n+1]= 100; y[2*n+1]= 1120; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1140; z[2*n]= 0;  x[2*n+1]=  78; y[2*n+1]= 1140; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1160; z[2*n]= 0;  x[2*n+1]=  58; y[2*n+1]= 1160; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1180; z[2*n]= 0;  x[2*n+1]=  34; y[2*n+1]= 1180; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]=   0; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]=  14; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=10;
  //n=224
  
  
  //grain20B
  n++;
  //n=225
       x[2*n]= 402; y[2*n]=  960; z[2*n]= 0;  x[2*n+1]= 480; y[2*n+1]=  960; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 334; y[2*n]=  980; z[2*n]= 0;  x[2*n+1]= 526; y[2*n+1]=  980; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 318; y[2*n]= 1000; z[2*n]= 0;  x[2*n+1]= 554; y[2*n+1]= 1000; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 296; y[2*n]= 1020; z[2*n]= 0;  x[2*n+1]= 572; y[2*n+1]= 1020; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 272; y[2*n]= 1040; z[2*n]= 0;  x[2*n+1]= 586; y[2*n+1]= 1040; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 252; y[2*n]= 1060; z[2*n]= 0;  x[2*n+1]= 600; y[2*n+1]= 1060; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 232; y[2*n]= 1080; z[2*n]= 0;  x[2*n+1]= 610; y[2*n+1]= 1080; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 208; y[2*n]= 1100; z[2*n]= 0;  x[2*n+1]= 622; y[2*n+1]= 1100; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 186; y[2*n]= 1120; z[2*n]= 0;  x[2*n+1]= 632; y[2*n+1]= 1120; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 168; y[2*n]= 1140; z[2*n]= 0;  x[2*n+1]= 642; y[2*n+1]= 1140; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 146; y[2*n]= 1160; z[2*n]= 0;  x[2*n+1]= 652; y[2*n+1]= 1160; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 124; y[2*n]= 1180; z[2*n]= 0;  x[2*n+1]= 660; y[2*n+1]= 1180; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 106; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 666; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=10;
  //n=237
  
  //grain21
  n++;
  //n=238
       x[2*n]= 266; y[2*n]=  950; z[2*n]= 0;  x[2*n+1]= 300; y[2*n+1]= 920; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  14; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 306; y[2*n+1]= 926; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  30; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 318; y[2*n+1]= 926; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  44; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 322; y[2*n+1]= 934; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  56; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 328; y[2*n+1]= 944; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  74; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 332; y[2*n+1]= 956; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]=  88; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 336; y[2*n+1]= 964; z[2*n+1]=   0; r[n]=5;
  n++; x[2*n]= 104; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 342; y[2*n+1]= 970; z[2*n+1]=   0; r[n]=5;
  //n=245
 
  
  //grain22
  n++;
  //n=246
       x[2*n]= 750; y[2*n]= 118; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]=  46; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 750; y[2*n]= 156; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]=  84; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 750; y[2*n]= 194; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]= 124; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 780; y[2*n]= 208; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]= 162; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 812; y[2*n]= 222; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]= 198; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 842; y[2*n]= 238; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]= 234; z[2*n+1]=   0; r[n]=15;
  //n=251
  
  //grain23
  n++;
  //n=252
       x[2*n]= 910; y[2*n]= 10; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]= 268; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 890; y[2*n]= 18; z[2*n]= 0;  x[2*n+1]= 890; y[2*n+1]= 260; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 870; y[2*n]= 26; z[2*n]= 0;  x[2*n+1]= 870; y[2*n+1]= 250; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 850; y[2*n]= 34; z[2*n]= 0;  x[2*n+1]= 850; y[2*n+1]= 240; z[2*n+1]=   0; r[n]=15;
  //n=255
  
  //grain24
  n++;
  //n=256
       x[2*n]= 1138; y[2*n]= 0; z[2*n]= 0;  x[2*n+1]= 930; y[2*n+1]= 280; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1100; y[2*n]= 0; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]= 256; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1062; y[2*n]= 0; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]= 206; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1024; y[2*n]= 0; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]= 156; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  988; y[2*n]= 0; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]= 106; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  948; y[2*n]= 2; z[2*n]= 0;  x[2*n+1]= 910; y[2*n+1]=  56; z[2*n+1]=   0; r[n]=15;
  //n=261
  
  
  //grain25
  n++;
  //n=262
       x[2*n]=  950; y[2*n]= 294; z[2*n]= 0;  x[2*n+1]= 1162; y[2*n+1]=   0; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  968; y[2*n]= 320; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]=   4; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  976; y[2*n]= 346; z[2*n]= 0;  x[2*n+1]= 1186; y[2*n+1]=  72; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1046; y[2*n]= 304; z[2*n]= 0;  x[2*n+1]= 1144; y[2*n+1]= 174; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1092; y[2*n]= 290; z[2*n]= 0;  x[2*n+1]= 1114; y[2*n+1]= 260; z[2*n+1]=   0; r[n]=15;
  //n=266
  
  
  //grain26
  n++;
  //n=267
       x[2*n]= 1186; y[2*n]=  74; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 120; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1168; y[2*n]= 120; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 226; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1155; y[2*n]= 170; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 328; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1134; y[2*n]= 216; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 436; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1116; y[2*n]= 262; z[2*n]= 0;  x[2*n+1]= 1174; y[2*n+1]= 470; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1094; y[2*n]= 294; z[2*n]= 0;  x[2*n+1]= 1150; y[2*n+1]= 484; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1064; y[2*n]= 304; z[2*n]= 0;  x[2*n+1]= 1124; y[2*n+1]= 506; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1036; y[2*n]= 316; z[2*n]= 0;  x[2*n+1]= 1100; y[2*n+1]= 536; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1010; y[2*n]= 330; z[2*n]= 0;  x[2*n+1]= 1080; y[2*n+1]= 576; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  984; y[2*n]= 344; z[2*n]= 0;  x[2*n+1]= 1064; y[2*n+1]= 626; z[2*n+1]=   0; r[n]=15;
  //n=276
  
  //grain27
  n++;
  //n=277
       x[2*n]= 1028; y[2*n]=  972; z[2*n]= 0;  x[2*n+1]= 1068; y[2*n+1]= 624; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1058; y[2*n]=  978; z[2*n]= 0;  x[2*n+1]= 1110; y[2*n+1]= 522; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1088; y[2*n]=  982; z[2*n]= 0;  x[2*n+1]= 1146; y[2*n+1]= 488; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1116; y[2*n]=  990; z[2*n]= 0;  x[2*n+1]= 1176; y[2*n+1]= 468; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1142; y[2*n]=  998; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 450; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1172; y[2*n]= 1004; z[2*n]= 0;  x[2*n+1]= 1200; y[2*n+1]= 746; z[2*n+1]=   0; r[n]=15;
  //n=282
 
 //grain28
  n++;
  //n=283
       x[2*n]=  900; y[2*n]= 636; z[2*n]= 0;  x[2*n+1]=  922; y[2*n+1]= 620; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  904; y[2*n]= 672; z[2*n]= 0;  x[2*n+1]=  974; y[2*n+1]= 620; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  908; y[2*n]= 706; z[2*n]= 0;  x[2*n+1]= 1020; y[2*n+1]= 622; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  912; y[2*n]= 740; z[2*n]= 0;  x[2*n+1]= 1068; y[2*n+1]= 626; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  966; y[2*n]= 738; z[2*n]= 0;  x[2*n+1]= 1060; y[2*n+1]= 668; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 1014; y[2*n]= 738; z[2*n]= 0;  x[2*n+1]= 1056; y[2*n+1]= 708; z[2*n+1]=   0; r[n]=15;
  //n=288
  
  //grain29
  n++;
  //n=289
       x[2*n]= 910; y[2*n]= 740; z[2*n]= 0;  x[2*n+1]= 1054; y[2*n+1]= 740; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 912; y[2*n]= 760; z[2*n]= 0;  x[2*n+1]= 1052; y[2*n+1]= 760; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 916; y[2*n]= 780; z[2*n]= 0;  x[2*n+1]= 1050; y[2*n+1]= 780; z[2*n+1]=   0; r[n]=10;
  n++; x[2*n]= 920; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 1048; y[2*n+1]= 800; z[2*n+1]=   0; r[n]=10;
  //n=292
  
  //grain30
  n++;
  //n=293
       x[2*n]= 1028; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 1042; y[2*n+1]= 824; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  992; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 1038; y[2*n+1]= 874; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  956; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 1032; y[2*n+1]= 922; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  922; y[2*n]= 800; z[2*n]= 0;  x[2*n+1]= 1028; y[2*n+1]= 970; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  928; y[2*n]= 868; z[2*n]= 0;  x[2*n+1]=  988; y[2*n+1]= 962; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]=  932; y[2*n]= 922; z[2*n]= 0;  x[2*n+1]=  950; y[2*n+1]= 954; z[2*n+1]=   0; r[n]=15;
  //n=298
  
  //grain31
  n++;
  //n=299
       x[2*n]= 1100; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 1030; y[2*n+1]= 1186; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1188; z[2*n]= 0;  x[2*n+1]= 1026; y[2*n+1]= 1154; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1160; z[2*n]= 0;  x[2*n+1]= 1015; y[2*n+1]= 1120; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1132; z[2*n]= 0;  x[2*n+1]= 1000; y[2*n+1]= 1090; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1102; z[2*n]= 0;  x[2*n+1]=  970; y[2*n+1]= 1054; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1070; z[2*n]= 0;  x[2*n+1]=  955; y[2*n+1]= 1020; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1042; z[2*n]= 0;  x[2*n+1]=  950; y[2*n+1]=  990; z[2*n+1]= 0; r[n]=15;
  n++; x[2*n]= 1200; y[2*n]= 1010; z[2*n]= 0;  x[2*n+1]=  950; y[2*n+1]=  958; z[2*n+1]= 0; r[n]=15;
  //n=306


  //grain32
  n++;
  //n=307
       x[2*n]= 778; y[2*n]=  610; z[2*n]= 0;  x[2*n+1]= 796; y[2*n+1]=  644; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 760; y[2*n]=  640; z[2*n]= 0;  x[2*n+1]= 804; y[2*n+1]=  704; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 740; y[2*n]=  666; z[2*n]= 0;  x[2*n+1]= 812; y[2*n+1]=  772; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 720; y[2*n]=  690; z[2*n]= 0;  x[2*n+1]= 820; y[2*n+1]=  842; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 698; y[2*n]=  710; z[2*n]= 0;  x[2*n+1]= 830; y[2*n+1]=  904; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 674; y[2*n]=  726; z[2*n]= 0;  x[2*n+1]= 838; y[2*n+1]=  974; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 650; y[2*n]=  742; z[2*n]= 0;  x[2*n+1]= 846; y[2*n+1]= 1044; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 650; y[2*n]=  800; z[2*n]= 0;  x[2*n+1]= 852; y[2*n+1]= 1106; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 650; y[2*n]=  856; z[2*n]= 0;  x[2*n+1]= 860; y[2*n+1]= 1178; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 700; y[2*n]=  986; z[2*n]= 0;  x[2*n+1]= 838; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 700; y[2*n]= 1040; z[2*n]= 0;  x[2*n+1]= 804; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 700; y[2*n]= 1096; z[2*n]= 0;  x[2*n+1]= 766; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 700; y[2*n]= 1146; z[2*n]= 0;  x[2*n+1]= 732; y[2*n+1]= 1200; z[2*n+1]=   0; r[n]=15;
  //n=319
  
  
  //grain33
  n++;
  //n=320
       x[2*n]= 550; y[2*n]=  880; z[2*n]= 0;  x[2*n+1]= 550; y[2*n+1]= 794; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 580; y[2*n]= 1034; z[2*n]= 0;  x[2*n+1]= 580; y[2*n+1]= 784; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 610; y[2*n]= 1076; z[2*n]= 0;  x[2*n+1]= 610; y[2*n+1]= 768; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 640; y[2*n]= 1136; z[2*n]= 0;  x[2*n+1]= 640; y[2*n+1]= 750; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 670; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 670; y[2*n+1]= 900; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= 700; y[2*n]= 1200; z[2*n]= 0;  x[2*n+1]= 700; y[2*n+1]= 930; z[2*n+1]=   0; r[n]=15;
  //n=325
 
  /* 14
  
       x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  n++; x[2*n]= ; y[2*n]= ; z[2*n]= 0;  x[2*n+1]= ; y[2*n+1]= ; z[2*n+1]=   0; r[n]=15;
  
  */
  
  setAngle(false);
  
  // area (1200x1200)*2
  
  // PILINDROS CONSTRUCTOR
  //(x ini  , y ini   , z ini   , x fin  , y fin   , z fin   , alt , raio , #pontos  , slope )
  
  for (int i=0; i<325; i++)
  {
    p[i] = new P (x[2*i],y[2*i],z[2*i],x[2*i+1],y[2*i+1],z[2*i+1],50, r[i],15,s[i]);
  }
  
  for (int i=0; i<325; i++)
  {
    p[325+i] = new P (h+h-y[2*i],x[2*i],z[2*i], h+h-y[2*i+1],x[2*i+1],z[2*i+1],50, r[i],15,s[325+i]);
  }
  
  for (int i=0; i<325; i++)
  {
    p[650+i] = new P (x[2*i],w+w-y[2*i],z[2*i],x[2*i+1],w+w-y[2*i+1],z[2*i+1],50, r[i],15,s[650+i]);
  }
  
  for (int i=0; i<325; i++)
  {
    p[975+i] = new P (h+h-x[2*i],w+w-y[2*i],z[2*i],h+h-x[2*i+1],w+w-y[2*i+1],z[2*i+1],50, r[i],15,s[975+i]);
  }
  
  
  
  
  
  
  /*
  for (int i=0; i<14; i++)
  p[i] = new P (1+60*i,0,0 ,0,1+60*i,0, 80, 25, 10, 0.6);
  for (int i=14; i<28; i++)
  p[i] = new P (1+60*(i-14),800-1,0 , 1+60/2*(i-14),800-60/2*(i-14)-1,0, 80, 25, 10, 1.2);
  for (int i=28; i<38; i++)
  p[i] = new P (400+60/sqrt(2)*(i-28)+1, 400-60/sqrt(2)*(i-28)+1,0  ,400+60/sqrt(2)*(i-28)+1,400+60/sqrt(2)*(i-28)+1,0,  80, 25, 10, 2.5 );
  */
             
  
}


public void setAngle (boolean modify)
{ 
  n=0;
  for (int i=0 ; i<4; i++)
  {
    println(">>>"+i);
    n=0;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]= random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=random(0,maxS);
    n+=11;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=random(0,maxS);
    n+=15;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=s[n+18]=random(0,maxS);
    n+=19;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=random(0,maxS);
    n+=12;
    s[n]=s[n+1]=s[n+2]=random(0,maxS);
    n+=3;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]= random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    
    
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]= random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=random(0,maxS);
    n+=11;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=random(0,maxS);
    n+=15;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=s[n+18]=random(0,maxS);
    n+=19;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=random(0,maxS);
    n+=12;
    s[n]=s[n+1]=s[n+2]=random(0,maxS);
    n+=3;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]= random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]= random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=random(0,maxS);
    n+=11;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=random(0,maxS);
    n+=15;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=s[n+18]=random(0,maxS);
    n+=19;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=random(0,maxS);
    n+=12;
    s[n]=s[n+1]=s[n+2]=random(0,maxS);
    n+=3;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]= random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]= random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=random(0,maxS);
    n+=11;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=random(0,maxS);
    n+=15;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=random(0,maxS);
    n+=14;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=s[n+18]=random(0,maxS);
    n+=19;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=random(0,maxS);
    n+=12;
    s[n]=s[n+1]=s[n+2]=random(0,maxS);
    n+=3;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=s[n+13]=s[n+14]=s[n+15]=s[n+16]=s[n+17]=random(0,maxS);
    n+=18;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=random(0,maxS);
    n+=9;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=random(0,maxS);
    n+=5;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=random(0,maxS);
    n+=10;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=random(0,maxS);
    n+=4;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]= random(0,maxS);
    n+=8;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=s[n+6]=s[n+7]=s[n+8]=s[n+9]=s[n+10]=s[n+11]=s[n+12]=random(0,maxS);
    n+=13;
    s[n]=s[n+1]=s[n+2]=s[n+3]=s[n+4]=s[n+5]=random(0,maxS);
    n+=6;
    
    if (modify)
    {
      for (int j=0; j<325; j++){
      p[325*i+j].setS(s[j]);
      }
    }
  }
}
class P
{
  PGraphics pg;
  int pts = 10;               // overrides constructor
  float t = 0;
  float delta;
  float sX, sY;
  float x, y, z, rot;
  float larg;
  float radius = 99;          // overrides constructor
  float h = 300;              // overrides constructor

  //vertices
  PVector vertices[][];
  PVector vN, vAux;

  P (float _x, float _y, float _z, float _rot, float _larg, int _h, float _radius, int _points, float slope)
  {//(x medio , y medio , z medio , ang rotac , largura    ,alt med, raio pontas  , pontos      )
    
    pg=Main;  // overrides any imposition
    vC= new PVector (0,0,0);
    vertices = new PVector[2][pts+1];
    x=_x;
    y=_y;
    z=_z;
    rot=radians(_rot);
    larg=_larg;
    h=_h;
    radius = _radius+2;
    vN= unit(-cos(rot), sin(rot), 1);
    //sX=1;
    sX= slope;
    sY=0;

    calcPts();
  }
  
  P (float x1, float y1, float z1, float x2, float y2, float z2, int _h, float _radius, int _points, float slope)
  {//(x ini  , y ini   , z ini   , x fin  , y fin   , z fin   , alt , raio , #pontos   )
    
    pg=Main;  // overrides any imposition
    vC= new PVector (0,0,0);
    vertices = new PVector[2][pts+1];
    x=(x1+x2)/2;
    y=(y1+y2)/2;
    z=(z1+z2)/2;
    rot=-atan2((x2-x1),(y2-y1));
    larg=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))-40;
    h=_h;
    radius = _radius+10;
    vN= unit(-cos(rot), sin(rot), 1);
    sX=slope;
    sY=0;

    calcPts();
  }


  public void setS (float _sX, float _sY)
  {
    sX=_sX;
    sY=_sY;
    calcPts();
  }
  public void setS (float _sX)
  {
    sX=_sX;
    calcPts();
  }
  public void incS (float _isX)
  {
    sX+=_isX;
    calcPts();
  }
  public void incR (float _inc)
  {
    rot+=_inc;
    calcPts();
  }
  public void incL (float _inc)
  {
    larg+=_inc;
    calcPts();
  }

  // calcula pontos
  public void calcPts ()
  {
    //println("recalc" + millis());
    vAux = unit (-sX*cos(rot), -sX*sin(rot), 1);
    vN.set(vAux);        // no P3D sem altera\u00e7\u00e3o de matriz


    for (int i = 0; i < 2; i++) {
      t = 0;
      float cte=larg/2;
      for(int j = 0; j <= pts; j++) {
        if (j==pts/2+1) cte=-larg/2;
        vertices[i][j] = new PVector();

        vertices[i][j].x = cos(radians(t)) * radius;
        vertices[i][j].y = sin(radians(t)) * radius+cte;
        if (i==0)
          vertices[i][j].z = (sX*cos(radians(t))+sY*sin(radians(t))) * radius;
        else
          vertices[i][j].z = h;
        t += 360.f/pts;
      }
      h *= -1;
    }
  }

  public void draw ()
  {
    pg.pushMatrix();
    pg.beginDraw();

    delta=PVector.angleBetween(vN, vC);

    pg.translate(x,y);
    pg.stroke(255);
    //pg.strokeWeight(2);
    //println(vN.x);
    //pg.line (0,0,0,50*vN.x, 50*vN.y, 50*vN.z);
    pg.strokeWeight(1);

    pg.rotateZ(rot);

    pg.noStroke();

    // draw cylinder tube
    if (lid==2){
      
      pg.beginShape(TRIANGLE_STRIP);
      for(int j = 0; j <= pts; j++)
      {
        pg.vertex(vertices[0][j].x, vertices[0][j].y, vertices[0][j].z);
        pg.vertex(vertices[1][j].x, vertices[1][j].y, vertices[1][j].z);
      }
      pg.vertex(vertices[0][0].x, vertices[0][0].y, vertices[0][0].z);
      pg.vertex(vertices[1][0].x, vertices[1][0].y, vertices[1][0].z);
      pg.endShape();
    }
    

    //println (cos(delta));

    //draw cylinder lids
    for (int i = 0; i < lid; i++) {
      if (i==0 && lightsmode==0) pg.fill (cos(delta)*200);//fill(cos(delta)*60, cos(delta)*150, cos(delta)*230);
      if (i==1 && lightsmode==0) pg.fill(180);
      pg.beginShape();
      for(int j = 0; j <= pts; j++) {
        pg.vertex(vertices[i][j].x, vertices[i][j].y, vertices[i][j].z);
      }
      pg.endShape(CLOSE);
    }

/*
    //draw normal
    pg.stroke(0,0,255);
    pg.line (0,0,0,0,0,20);
    pg.stroke(0,255,0);
    pg.line (0,0,0,0,-20,0);
    pg.stroke(255,0,0);
    pg.line (0,0,0,20,0,0);
    pg.stroke(50);
    //println(vN.x);
    pg.line (0,0,0,20*vN.x, 0, 20*vN.z);
    pg.noStroke();
*/
    pg.endDraw();
    pg.popMatrix();
  }


  public PVector unit (float x, float y, float z)
  {
    float mod=sqrt(x*x+y*y+z*z);
    PVector un = new PVector (x/mod, y/mod, z/mod);
    return un;
  }
}
// http://processing.org/learning/3d/shapetransform.html

PImage metalog;
boolean runonce;

public void showTeoria ()
{
  int h, w;
  float l, fontsize;
  h=PApplet.parseInt(height*0.8f);
  w=PApplet.parseInt(width*0.8f);
  fontsize = 14;
  
  // BOTOES MANAGEMENT

  if (next.isSelected()) 
  {
    if (teo<4) teo++;
    else teoria.unSelect();
    runonce=false;
    next.unSelect();
    controls.unSelect();
  }
  if (prev.isSelected()) 
  {
    if (teo>1) teo--;
    else teoria.unSelect();
    runonce=false;
    prev.unSelect();
    controls.unSelect();
  }
 
  pushMatrix();
  //fill (255,120);
  //rect (0,0,width, height);
  
  translate ((width-w)/2, (height-h)/2-15);
  fill (180,220,250,220);
  noStroke();
  rect (0,0, w, h);

  fill(0);
  textAlign(CENTER);
  textFont (verd, 18);
  text ("METALOGRAFIA",w/2, 30);
  textAlign(LEFT);
  
  
  textFont (verdS, 15);
  
  switch (teo)
  {
    case 1:
    
    text ("Esta anima\u00e7\u00e3o ilustra a micrografia de um material policristalino feita em\n"+
          "um microsc\u00f3pio \u00f3tico. Este tipo de an\u00e1lise denomina-se metalografia.\n"+
          "Uma amostra \u00e9 preparada polindo-se sua superf\u00edcie por meio de diversos\n"+
          "processos, obtendo-se ao fim um acabamento liso e espelhado. Executa-se\n"+
          "ent\u00e3o um tratamento qu\u00edmico cuja reatividade depende da orienta\u00e7\u00e3o\n"+
          "cristalogr\u00e1fica da superf\u00edcie dos gr\u00e3os, fazendo com que eles reajam \n"+
          "diferentemente. Como consequ\u00eancia dos processos polimento - ataque qu\u00edmico\n"+
          "mencionados, a luz que incide normalmente na amostra \u00e9 refletida em angulos\n"+
          "diferentes por cada gr\u00e3o, possibilitando sua identifica\u00e7\u00e3o, bem como dos \n"+
          "contornos\nde gr\u00e3o."

          ,15, 80);
          
    text ("VOLTAR", 50,434);
    textAlign(CENTER);
    text ("Clque\naqui\npara\ncontinuar", 500,374);
    textAlign(LEFT);
     
    image (metalog, 140,250);
    textFont(verdSS,8);
    text ("INVESTIGA\u00c7\u00c3O   DA   ESTABILIDADE   DE  MATERIAIS   BIOCOMPAT\u00cdVEIS  POR\nAN\u00c1LISE MICROESTRUTURAL. Soc. Brasileira de Qu\u00edmica - 23\u00aaReuni\u00e3o Anual\n", 140,455);
     //http://www.sbq.org.br/ranteriores/23/resumos/0301/index.html
     
    break;
    
    case 2:
  
    if (!runonce) 
    {
      ro=3500;
      th=-PI/4;
      fi=0.7f;
      focX=1200;//width/2;
      focY=1200;//height/2;
      mx=roamW/2;
      my=roamH/2;
      
      runonce=true;
    }
    
    text ("A imagem abaixo representa a amostra em um espa\u00e7o tridimendional.\n"+
          "Cada gr\u00e3o reflete a luz em um \u00e2ngulo diverso, gerando diferentes tons\n"+
          "de cinza em diferentes \u00e2ngulos de vis\u00e3o.\n"+
          "As partes mais claras correspondem aos planos cuja dire\u00e7\u00e3o normal est\u00e1 \n"+
          "mais alinhada com a dire\u00e7\u00e3o da c\u00e2mera.\n"

          ,15, 80);
    
    pushStyle();
    
    fill (200,120);
    rect (10,330,95,90);
    
    image (mouse, 35,355);
    
    tint(127,250,200);
    image (rotacao, 70,335,30,30);
    
    tint (127,200,250);
    image (seta, 15,380);
    
    tint (200,240,255);
    image (Main, 110,170,360,300);

    popStyle();
    
    break;
    
    
    case 3:
    
    text ("A imagem vista ao microc\u00f3pio corresponde a vis\u00e3o normal em rela\u00e7\u00e3o \u00e0\n"+
          "superf\u00edcie da amostra, como ilustrado abaixo. Nessa situa\u00e7\u00e3o, a luz incide \n"+
          "verticalmente na amostra e o brilho de seu reflexo varia com o \u00e2ngulo \n"+
          "do plano cristalogr\u00e1fico. Quanto maior o brilho, menor o \u00e2ngulo\n"+
          "formado entre a normal do plano e a dire\u00e7\u00e3o da vis\u00e3o do observador.\n"

          ,15, 80);
    
    if (!runonce) 
    {
      ro=2200;
      fi=0.0001f;
      th=PI;
      focX=1200;//width/2;
      focY=1200;//height/2;
      mx=roamW/2;
      my=roamH/2;
      
      runonce=true;
    }
    
    pushStyle();
    
    fill (200,120);
    rect (10,330,95,90);
    
    image (mouse, 35,355);
    
    tint(127,250,200);
    image (rotacao, 70,335,30,30);
    
    tint (127,200,250);
    image (seta, 15,380);
    
    tint (200,240,255);
    image (Main, 110,170,360,300);

    popStyle();
    
    break;
    
    
    case 4:
    
    text ("Para mudar a vis\u00e3o da c\u00e2mera no espa\u00e7o tridimensional, existem \n"+
"                                                                                                                       3 controles:"+
          "\nROTA\u00c7\u00c3O:\n\n"+
          "MOUSE - Arrastando o bot\u00e3o esquerdo (direito quando esta janela estiver \n"+
          "ativa) do mouse \u00e9 poss\u00edvel rotacionar a amostra em torno do eixo vertical\n"+
          "e do eixos horizontal ortogonal \u00e0 dire\u00e7\u00e3o da c\u00e2mera. \n"+
          "\n TRANSLA\u00c7\u00c3O:\n\n"+
          "MAPA - A regi\u00e3o azul escura no canto superior direito da janela \u00e9 o Mapa, \n"+
          "onde \u00e9 poss\u00edvel determinar a posi\u00e7\u00e3o do foco da camera (centro da vis\u00e3o)\n"+
          "clicando ou arrastando o mouse em qualquer ponto dentro do ret\u00e2ngulo\n\n"+
          "JOYSTICK - O circulo azul claro no canto inferior direito da janela \u00e9 o \n"+
          "Joystick. Ele permite navegar pelo espa\u00e7o no plano da superf\u00edcie da\n"+
          "amostra. Clique e segure o mouse em uma dire\u00e7\u00e3o da regi\u00e3o azul para\n"+
          "movimentar a c\u00e2mera nessa dire\u00e7\u00e3o at\u00e9 alcancar os limites da amostra."

          ,15, 80);
          
    text ("FIM", 486,434);
    
    if (!runonce) 
    {
      runonce=true;
    }
    
    if (!maisinfo.isSelected()) controlst.display();
    
    pushMatrix();
    pushStyle();
    resetMatrix();
    image (Camxy, width-roamW, 0);
    tint (255,150); // trickery
    image (Joy, joyX-joyRad, joyY-joyRad); 
    popStyle();
    popMatrix();
    
    //image (Camxy, 110,170);
  }
  
  // BOTOES DISPLAY
  next.display();
  prev.display();
  
  popMatrix();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "R77" });
  }
}
